<ComClass(WaldoNavPad.ClassId, WaldoNavPad.InterfaceId, WaldoNavPad.EventsId)> Public Class WaldoNavPad
    Public Const ClassId As String = "1B883E97-B2CB-48cf-8B47-87AAA589C289"
    Public Const InterfaceId As String = "FC8C3B3E-1D69-414e-A2FD-6394993C059A"
    Public Const EventsId As String = "EBC6EF56-7DD5-4555-A30A-B3BC0B8E11BF"

    Private mText As String

    Private mTextPointer As Integer
    Private mPrevTextPointer As Integer
    Private mPrevSeperator As Integer
    Private mTextFieldLength As Integer
    Private mDialogResult As Boolean
    Private mFormTitle As String
    Private mOKButtonText As String
    Private mCancelButtonText As String
    Private mTextChanged As Boolean
    Private mChangedWarningText As String
    Private mChangedWarningTitleText As String
    Private mFont As Font
    Private mFontSize As Integer
    Private mFontName As String
    Private mReadOnlyPane As Boolean

    Public Sub New()
        mTextPointer = 0
        mPrevTextPointer = 0
        mPrevSeperator = 0
        mTextChanged = False
        mReadOnlyPane = False

        mFormTitle = "Waldo Dynamics NAV Textpad"
    End Sub

    Public Property TextFieldLength() As Integer
        Get
            Return mTextFieldLength
        End Get
        Set(ByVal Value As Integer)
            mTextFieldLength = Value
        End Set
    End Property
    Public Property Text() As String
        Get
            Return mText
        End Get
        Set(ByVal Value As String)
            mText = Value
            mTextChanged = False
        End Set
    End Property
    Public ReadOnly Property EOS() As Boolean
        Get
            If Count() <= mTextPointer Then
                Return True
            Else
                Return False
            End If
        End Get
    End Property
    Public ReadOnly Property TextPointer() As Integer
        Get
            Return mTextPointer
        End Get
    End Property
    Public Property FormTitle() As String
        Get
            Return mFormTitle
        End Get
        Set(ByVal Value As String)
            mFormTitle = Value
        End Set
    End Property
    Public ReadOnly Property Count() As Integer
        Get
            Return mText.Length
        End Get
    End Property

    Public Property OKButtonText() As String
        Get
            If mOKButtonText = "" Then
                Return "&OK"
            Else
                Return mOKButtonText
            End If
        End Get
        Set(ByVal Value As String)
            mOKButtonText = Value
        End Set
    End Property
    Public Property CancelButtonText() As String
        Get
            If mCancelButtonText = "" Then
                Return "&Cancel"
            Else
                Return mCancelButtonText
            End If
        End Get
        Set(ByVal Value As String)
            mCancelButtonText = Value
        End Set
    End Property
    Public ReadOnly Property DialogResultOK() As Boolean
        Get
            Return mDialogResult
        End Get
    End Property
    Public Property TextChanged() As Boolean
        Get
            Return mTextChanged
        End Get
        Set(ByVal value As Boolean)
            mTextChanged = value
        End Set
    End Property
    Public Property ChangedWarningText() As String
        Get
            If mChangedWarningText = "" Then
                Return "The text has been changed.  Are you sure to cancel?"
            Else
                Return mChangedWarningText
            End If
        End Get
        Set(ByVal Value As String)
            mChangedWarningText = Value
        End Set
    End Property
    Public Property ChangedWarningTitleText() As String
        Get
            If mChangedWarningTitleText = "" Then
                Return "Warning: Text changed!"
            Else
                Return mChangedWarningTitleText
            End If
        End Get
        Set(ByVal Value As String)
            mChangedWarningTitleText = Value
        End Set
    End Property
    Public WriteOnly Property FontSize() As Integer
        Set(ByVal value As Integer)
            mFontSize = value
        End Set
    End Property
    Public WriteOnly Property FontName() As String
        Set(ByVal value As String)
            mFontName = value
        End Set
    End Property
    Public ReadOnly Property Font() As Font
        Get
            If mFontSize = 0 Then mFontSize = 10
            If mFontName = "" Then mFontName = "Verdana"
            mFont = New Font(mFontName, mFontSize, FontStyle.Regular)
            Return mFont
        End Get
    End Property
    Public Property ReadonlyPane() As Boolean
        Get
            Return mReadOnlyPane
        End Get
        Set(ByVal value As Boolean)
            mReadOnlyPane = value
        End Set
    End Property


    Public Sub ShowDialog()
        Dim frmNavEditor As New frmNavEditor(Me)

        frmNavEditor.Text = mFormTitle
        frmNavEditor.ShowDialog()
        If frmNavEditor.DialogResult = DialogResult.OK Then
            mDialogResult = True
        Else
            mDialogResult = False
        End If

        frmNavEditor = Nothing
    End Sub

    Public Sub AppendText(ByVal ptext As String)
        mText &= ptext
    End Sub

    Public Sub ResetTextPointer()
        mTextPointer = 0
    End Sub

    Public Sub GetNextTextField(ByRef ReturnText As String, ByRef ReturnSeperator As Integer)
        'In Navision, the seperator is an option.  An option can be used as an integer
        ' 0 = no seperator
        ' 1 = space
        ' 2 = carriage return

        SetTextPointer(ReturnSeperator)
        ReturnText = mText.Substring(mPrevTextPointer, (mTextPointer - mPrevTextPointer))

    End Sub

    Private Sub SetTextPointer(ByRef Seperator As Integer)

        Select Case mPrevSeperator
            Case 1 'space
                mTextPointer += 1
            Case 2 'carriage return
                mTextPointer += 1
        End Select

        mPrevTextPointer = mTextPointer

        'first find new carriage return
        If Not SetTextPointerToNextCR() Then
            If (Count() - mTextPointer) > TextFieldLength Then
                If Not SetTextPointerToNextSpace() Then
                    SetTextPointerToFieldLength()
                    Seperator = 0
                Else
                    Seperator = 1
                End If
            Else
                SetTextPointerToFieldLength()
                Seperator = 0
            End If
        Else
            Seperator = 2
        End If

        mPrevSeperator = Seperator
    End Sub

    Private Function SetTextPointerToNextCR() As Boolean
        Dim TempPointerCR As Integer
        Dim char10 As Char
        char10 = Chr(10)

        TempPointerCR = mText.IndexOf(char10, mTextPointer)

        If (TempPointerCR = -1) Then
            Return False
        Else
            If (TempPointerCR - mTextPointer) > mTextFieldLength Then
                Return False
            Else
                mTextPointer = TempPointerCR
                Return True
            End If
        End If

    End Function

    Private Function SetTextPointerToNextSpace() As Boolean
        Dim TempPointerSPACE As Integer
        Dim TempPointer As Integer
        Dim EndLoop As Boolean

        TempPointer = mTextPointer
        EndLoop = False
        Do While EndLoop = False
            TempPointer = mText.IndexOf(" "c, TempPointer)
            If TempPointer = -1 Then
                EndLoop = True
            ElseIf (TempPointer - mTextPointer) > mTextFieldLength Then
                EndLoop = True
            Else
                TempPointerSPACE = TempPointer
                TempPointer += 1 'Pass current space (else endless loop)
            End If
        Loop
        If TempPointer > 0 Then TempPointer -= 1 'go back from previous space-passing

        If (TempPointerSPACE <= 0) Then
            Return False
        Else
            If (TempPointerSPACE - mTextPointer) > mTextFieldLength Then
                Return False
            Else
                mTextPointer = TempPointerSPACE
                Return True
            End If
        End If
    End Function

    Private Function SetTextPointerToFieldLength() As Boolean
        If (Count() - mPrevTextPointer) > mTextFieldLength Then
            mTextPointer += mTextFieldLength
        Else
            mTextPointer = Count()
        End If
    End Function
End Class